#pragma config(Motor,  port1,           rFDM,          tmotorVex393TurboSpeed_HBridge, openLoop, reversed)
#pragma config(Motor,  port2,           rMDM,          tmotorVex393TurboSpeed_MC29, openLoop, reversed)
#pragma config(Motor,  port3,           rRDM,          tmotorVex393TurboSpeed_MC29, openLoop)
#pragma config(Motor,  port4,           rLift,         tmotorVex393HighSpeed_MC29, openLoop)
#pragma config(Motor,  port5,           rClaw,         tmotorVex393HighSpeed_MC29, openLoop)
#pragma config(Motor,  port6,           lClaw,         tmotorVex393HighSpeed_MC29, openLoop, reversed)
#pragma config(Motor,  port7,           lLift,         tmotorVex393HighSpeed_MC29, openLoop, reversed)
#pragma config(Motor,  port8,           lFDM,          tmotorVex393TurboSpeed_MC29, openLoop, reversed)
#pragma config(Motor,  port9,           lMDM,          tmotorVex393TurboSpeed_MC29, openLoop)
#pragma config(Motor,  port10,          lRDM,          tmotorVex393TurboSpeed_HBridge, openLoop)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

// This file is part of Vex-920-2016, and is therefore licensed under the GNU GPLv3 public license.
// Copyright (C) 2016  Ganden Schaffner

/* Controls
	Ch2: Arm: Raise and lower
	Ch3: Movement: Forwards and backwards
	Ch4: Movement: Rotation
	Btn5D: Claw: Open
	Btn6D: Claw: Close
*/

// This code is for the VEX cortex platform
#pragma platform(VEX2)

// Select Download method as "competition"
#pragma competitionControl(Competition)

//Main competition background code...do not modify!
#include "Vex_Competition_Includes.c"

// Methods
/*! Moves the bot based on input from the left stick.
*/
void moveStick() {
	motor[rFDM] = vexRT[Ch3] - vexRT[Ch4] * 0.5;
	motor[rMDM] = vexRT[Ch3] - vexRT[Ch4] * 0.5;
	motor[rRDM] = vexRT[Ch3] - vexRT[Ch4] * 0.5;
	motor[lFDM] = vexRT[Ch3] + vexRT[Ch4] * 0.5;
	motor[lMDM] = vexRT[Ch3] + vexRT[Ch4] * 0.5;
	motor[lRDM] = vexRT[Ch3] + vexRT[Ch4] * 0.5;
}

/*! Raises and lowers the arm based on input from Ch2 (right stick).
	To avoid slamming, raises at full speed, lowers at half speed.
*/
void armControl() {
	float speed = (vexRT[Ch2] > 0) ? 1.0 : 0.5;
	motor[lLift] = vexRT[Ch2] * speed;
	motor[rLift] = vexRT[Ch2] * speed;
}

/*! Opens and closes the claw with buttons 5D and 6D.
*/
void clawControl() {
	if (vexRT[Btn5D] ^ vexRT[Btn6D]) {
		motor[rClaw] = vexRT[Btn6D] ? 60 : -60;
		motor[lClaw] = vexRT[Btn6D] ? 60 : -60;
	} else {
		motor[rClaw] = 0;
		motor[lClaw] = 0;
	}
}

/*---------------------------------------------------------------------------*/
/*                          Pre-Autonomous Functions                         */
/*                                                                           */
/*  You may want to perform some actions before the competition starts.      */
/*  Do them in the following function.  You must return from this function   */
/*  or the autonomous and usercontrol tasks will not be started.  This       */
/*  function is only called once after the cortex has been powered on and    */
/*  not every time that the robot is disabled.                               */
/*---------------------------------------------------------------------------*/

void pre_auton() {
	// Set bStopTasksBetweenModes to false if you want to keep user created tasks
	// running between Autonomous and Driver controlled modes. You will need to
	// manage all user created tasks if set to false.
	bStopTasksBetweenModes = true;

	// Set bDisplayCompetitionStatusOnLcd to false if you don't want the LCD
	// used by the competition include file, for example, you might want
	// to display your team name on the LCD in this function.
	bDisplayCompetitionStatusOnLcd = false;

	// All activities that occur before the competition starts
	// Example: clearing encoders, setting servo positions, ...
}

task autonomous() {
	AutonomousCodePlaceholderForTesting();
}

task usercontrol() {
	while (true)
	{
		moveStick();
		armControl();
	    clawControl();
	}
}
